Loading...
Searching...
No Matches
g2cparams.c File Reference

Functions for serving up NOAA parameter abbreviations and GRIB1/GRIB2 translations. More...

`#include "grib2_int.h"`

Go to the source code of this file.

## Macros

#define | CSV_FILE "noaa_grib2_params.csv"
| The name of the CSV file which contains the NOAA abbreviations.

## Functions

int | g2c_param_abbrev (int g2disc, int g2cat, int g2num, char *abbrev)
| Get NOAA abbreviation for a GRIB2 parameter.
int | g2c_param_all (int param_idx, int *g1num, int *g1ver, int *g2disc, int *g2cat, int *g2num, char *abbrev)
| Return all the information about a parameter.
int | g2c_param_g1tog2 (int g1num, int g1ver, int *g2disc, int *g2cat, int *g2num)
| Translate GRIB1 parameter to GRIB2 parameter.
int | g2c_param_g2tog1 (int g2disc, int g2cat, int g2num, int *g1num, int *g1ver)
| Translate GRIB2 parameter to GRIB1 parameter.

## Variables

static G2C_PARAM_T | param [G2C_MAX_NOAA_PARAMS]
| An array of parameter information.

## Detailed Description

Functions for serving up NOAA parameter abbreviations and GRIB1/GRIB2 translations.

Author
  Ed Hartnett

Date
  9/19/22

Definition in file g2cparams.c.

## Macro Definition Documentation

## CSV_FILE

#define CSV_FILE "noaa_grib2_params.csv"

The name of the CSV file which contains the NOAA abbreviations.

Definition at line 11 of file g2cparams.c.

## Function Documentation

## g2c_param_abbrev()

int g2c_param_abbrev | ( | int | g2disc,
|  | int | g2cat,
|  | int | g2num,
|  | char * | abbrev
| ) |  |

Get NOAA abbreviation for a GRIB2 parameter.

Parameters

  g2disc | The GRIB2 discipline number.
  g2cat | The GRIB2 category number.
  g2num | The GRIB2 parameter number.
  abbrev | Pointer that gets the abbreviation. Ignored if NULL.

Returns
  - G2C_NOERROR No error.
  - G2C_EFILE Error reading CSV file.
  - G2C_ENOPARAM Parameter not found.

Author
  Ed Hartnett

Date
  9/19/22

Definition at line 1091 of file g2cparams.c.

References G2C_MAX_NOAA_ABBREV_LEN, G2C_MAX_NOAA_PARAMS, G2C_NOERROR, LOG, and param.

Referenced by g2c_degrib2(), and g2c_log_section().

## g2c_param_all()

int g2c_param_all | ( | int | param_idx,
|  | int * | g1num,
|  | int * | g1ver,
|  | int * | g2disc,
|  | int * | g2cat,
|  | int * | g2num,
|  | char * | abbrev
| ) |  |

Return all the information about a parameter.

Parameters

  param_idx | Parameter index between 0 and G2C_MAX_NOAA_PARAMS.
  g1num | Pointer that gets the GRIB1 parameter. Ignored if NULL.
  g1ver | Pointer that gets the GRIB1 parameter table version number. Ignored if NULL.
  g2disc | Pointer that gets the GRIB2 discipline number. Ignored if NULL.
  g2cat | Pointer that gets the GRIB2 category number. Ignored if NULL.
  g2num | Pointer that gets the GRIB2 parameter number. Ignored if NULL.
  abbrev | Pointer that gets the abbreviation.

Returns
  - G2C_NOERROR No error.
  - G2C_EINVAL Invalid input.
  - G2C_EFILE Error reading CSV file.
  - G2C_ENOPARAM Parameter not found.

Author
  Ed Hartnett

Date
  9/19/22

Definition at line 1185 of file g2cparams.c.

References g2c_param::g1num, g2c_param::g1ver, G2C_EINVAL, G2C_MAX_NOAA_ABBREV_LEN, G2C_MAX_NOAA_PARAMS, G2C_NOERROR, g2c_param::g2cat, g2c_param::g2disc, g2c_param::g2num, and param.

## g2c_param_g1tog2()

int g2c_param_g1tog2 | ( | int | g1num,
|  | int | g1ver,
|  | int * | g2disc,
|  | int * | g2cat,
|  | int * | g2num
| ) |  |

Translate GRIB1 parameter to GRIB2 parameter.

Parameters

  g1num | The GRIB1 parameter.
  g1ver | The GRIB1 parameter table version number.
  g2disc | Pointer that gets the GRIB2 discipline number. Ignored if NULL.
  g2cat | Pointer that gets the GRIB2 category number. Ignored if NULL.
  g2num | Pointer that gets the GRIB2 parameter number. Ignored if NULL.

Returns
  - G2C_NOERROR No error.
  - G2C_EFILE Error reading CSV file.
  - G2C_ENOPARAM Parameter not found.

Author
  Ed Hartnett

Date
  9/19/22

Definition at line 1051 of file g2cparams.c.

References G2C_ENOPARAM, G2C_MAX_NOAA_PARAMS, G2C_NOERROR, g2c_param::g2cat, g2c_param::g2disc, g2c_param::g2num, and param.

## g2c_param_g2tog1()

int g2c_param_g2tog1 | ( | int | g2disc,
|  | int | g2cat,
|  | int | g2num,
|  | int * | g1num,
|  | int * | g1ver
| ) |  |

Translate GRIB2 parameter to GRIB1 parameter.

Parameters

  g2disc | The GRIB2 discipline number.
  g2cat | The GRIB2 category number.
  g2num | The GRIB2 parameter number.
  g1num | Pointer that gets the GRIB1 parameter. Ignored if NULL.
  g1ver | Pointer that gets the GRIB1 parameter table version number. Ignored if NULL.

Returns
  - G2C_NOERROR No error.
  - G2C_EFILE Error reading CSV file.
  - G2C_ENOPARAM Parameter not found.

Author
  Ed Hartnett

Date
  9/19/22

Definition at line 1136 of file g2cparams.c.

References g2c_param::g1num, g2c_param::g1ver, G2C_ENOPARAM, G2C_MAX_NOAA_PARAMS, G2C_NOERROR, LOG, and param.

## Variable Documentation

## param

G2C_PARAM_T param[G2C_MAX_NOAA_PARAMS]

static

An array of parameter information.

Definition at line 14 of file g2cparams.c.

Referenced by g2c_param_abbrev(), g2c_param_all(), g2c_param_g1tog2(), and g2c_param_g2tog1().